// TrackerErrorMFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TrackerErrorMFC.h"
#include "TrackerErrorMFCDlg.h"

#include "..\..\include\TrackerErrorsDll.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTrackerErrorMFCDlg dialog




CTrackerErrorMFCDlg::CTrackerErrorMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTrackerErrorMFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTrackerErrorMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_errorNumber);
	DDX_Control(pDX, IDC_EDIT_SHORT, m_editShort);
	DDX_Control(pDX, IDC_EDIT_LONG, m_EditLong);
	DDX_Control(pDX, IDC_EDIT6, m_Auto);
	DDX_Control(pDX, IDC_EDIT_SOLUTION, m_solution);
}

BEGIN_MESSAGE_MAP(CTrackerErrorMFCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
	ON_EN_CHANGE(IDC_EDIT1, &CTrackerErrorMFCDlg::OnEnChangeEdit1)
END_MESSAGE_MAP()


// CTrackerErrorMFCDlg message handlers

BOOL CTrackerErrorMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_errorNumber.SetWindowTextW(_T("701"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTrackerErrorMFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTrackerErrorMFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


void CTrackerErrorMFCDlg::GetErrorInformation()
{
	CString cShortDescription, cLongDescription, cSolution, cAutoRecoverOnGreenState;
	CString cBlank=CString("---");
	bool bAutoRecoverOnGreenState;
	bool result;
	CString CErrorNumber;
	long lErrorNumber;

	m_errorNumber.GetWindowTextW(CErrorNumber);
	lErrorNumber=_ttol(CErrorNumber);

	//MFC
	result=GetTPIErrorDescription_CString(lErrorNumber,cShortDescription,
		cLongDescription,cSolution,bAutoRecoverOnGreenState);

	//Unicode STL
	//GetTPIErrorDescription_wString

	//STL
	//GetTPIErrorDescription_string

	if (result==false)
	{
		m_editShort.SetWindowTextW(cBlank);
		m_EditLong.SetWindowTextW(cBlank);
		m_Auto.SetWindowTextW(cBlank);
		m_solution.SetWindowTextW(cBlank);
		return;
	}

	cAutoRecoverOnGreenState=bAutoRecoverOnGreenState?"TRUE":"FALSE";

	m_editShort.SetWindowTextW(cShortDescription);
	m_EditLong.SetWindowTextW(cLongDescription);
	m_Auto.SetWindowTextW(cAutoRecoverOnGreenState);
	m_solution.SetWindowTextW(cSolution);

}


void CTrackerErrorMFCDlg::OnEnChangeEdit1()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	GetErrorInformation();
	// TODO:  Add your control notification handler code here
}

